Magellan Linux

Diff of /branches/mage-next/src/smage2.functions.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.functions.sh revision 1648 by niro, Fri Jan 13 20:51:18 2012 UTC branches/mage-next/src/smage2.functions.sh.in revision 3038 by niro, Fri Jun 30 12:20:12 2017 UTC
# Line 7  Line 7 
7  smagesource()  smagesource()
8  {  {
9   local file="$1"   local file="$1"
10   local mystate   local localstate
11   local mycodename   local distfilestate
12     local mytag
13    
14   source ${file}   source ${file}
15    
# Line 19  smagesource() Line 20  smagesource()
20   if [[ -n ${PCATEGORIE} ]]   if [[ -n ${PCATEGORIE} ]]
21   then   then
22   PCAT="${PCATEGORIE}"   PCAT="${PCATEGORIE}"
23     unset PCATEGORIE
24   # print a warning   # print a warning
25   echo -e "${COLYELLOW}Warning: 'PCATEGORIE' is deprecated and gets removed in the future.${COLDEFAULT}"   echo -e "${COLYELLOW}Warning: 'PCATEGORIE' is deprecated and gets removed in the future.${COLDEFAULT}"
26   echo -e "${COLYELLOW}         Please modify this smage2 script to use the 'PCAT' variable.${COLDEFAULT}"   echo -e "${COLYELLOW}         Please modify this smage2 script to use the 'PCAT' variable.${COLDEFAULT}"
# Line 28  smagesource() Line 30  smagesource()
30   fi   fi
31   fi   fi
32    
33   [[ -n ${STATE} ]] && mystate="${STATE}"   [[ -n ${STATE} ]] && localstate="${STATE}"
34     [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
  # do not overide if local state was broken or disabled!  
  case ${STATE} in  
  broken) return ;;  
  disabled) return ;;  
  esac  
35    
36   if [ -f ${SMAGESCRIPTSDIR}/distribution ]   if [ -f ${SMAGESCRIPTSDIR}/distribution ]
37   then   then
38   source ${SMAGESCRIPTSDIR}/distribution   source ${SMAGESCRIPTSDIR}/distribution
39   [[ -n ${STATE} ]] && mystate="${STATE}"   [[ -n ${STATE} ]] && distfilestate="${STATE}"
40     [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
41     fi
42     # now switch state and export it but do not overide any local states
43     if [[ ! -z ${localstate} ]]
44     then
45     STATE="${localstate}"
46     else
47     STATE="${distfilestate}"
48   fi   fi
  # now switch state and export it  
  STATE="${mystate}"  
 }  
   
 showversion()  
 {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die()  
 {  
  xtitleclean  
  echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 die_pipestatus()  
 {  
  # the status change if we do any parameter declarations!!  
  # dont do this anymore, keep this in mind!  
  #  
  # local pos="$1"  
  # local comment="$2"  
  #  
  # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"  
  #  
  [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"  
 }  
49    
50  xtitle()   if mqueryfeature "pkgdistrotag"
 {  
  if [[ ${TERM} = xterm ]]  
51   then   then
52   echo -ne "\033]0;[sMage: $@]\007"   # if DISTROTAG was not defined globally
53     # or in distribution file then deactivate this feature!
54     # at this point $mytag must have the distrotag
55     if [[ -z ${mytag} ]]
56     then
57     FVERBOSE=off msetfeature "!pkgdistrotag"
58     unset DISTROTAG
59     echo -e "${COLRED}Requested 'pkgdistrotag' but no \$DISTROTAG found!${COLDEFAULT}"
60     echo -e "${COLRED}Disabled the feature for pkgbuild sanity!${COLDEFAULT}"
61     else
62     # now switch state and export it but do not overide any local states
63     export DISTROTAG="${mytag}"
64     fi
65     else
66     unset DISTROTAG
67   fi   fi
  return 0  
68  }  }
69    
70  xtitleclean()  print_distrotag()
71  {  {
72   if [[ ${TERM} = xterm ]]   if FVERBOSE=off mqueryfeature "pkgdistrotag"
73   then   then
74   echo -ne "\033]0;\007"   if [[ ! -z ${DISTROTAG} ]]
75     then
76     # add a point as prefix
77     echo ".${DISTROTAG}"
78     fi
79   fi   fi
  return 0  
80  }  }
81    
82  syncsmage2()  syncsmage2()
# Line 191  download_sources() Line 180  download_sources()
180  }  }
181    
182  # dummy function, used if that does not exist in smage file  # dummy function, used if that does not exist in smage file
183    pkg_setup()
184    {
185     echo "no pkg_setup defined; doing nothing ..."
186     return 0
187    }
188    
189    # dummy function, used if that does not exist in smage file
190  src_prepare()  src_prepare()
191  {  {
192   echo "no src_prepare defined; doing nothing ..."   echo "no src_prepare defined; doing nothing ..."
# Line 247  mconfigure() Line 243  mconfigure()
243   fi   fi
244   fi   fi
245    
246   # always enable shared by default   # always enable shared by default but not for waf configure
247   if [[ ! -z $(./configure --help | grep -- '--.*able-shared') ]]   if [[ ! -z $(./configure --help | grep -- '--.*able-shared') ]] &&
248     [[ -z $(./configure --version | grep waf) ]]
249   then   then
250   myopts+=" --enable-shared"   myopts+=" --enable-shared"
251   fi   fi
# Line 283  minstall() Line 280  minstall()
280   sysconfdir=${BINDIR}/etc \   sysconfdir=${BINDIR}/etc \
281   libdir=${BINDIR}/usr/$(mlibdir) \   libdir=${BINDIR}/usr/$(mlibdir) \
282   "$@" install || die "minstall failed"   "$@" install || die "minstall failed"
283          else   else
284                  die "no Makefile found"   die "no Makefile found"
285          fi   fi
286  }  }
287    
288  mmake()  mmake()
# Line 308  munpack() Line 305  munpack()
305   DEST=$2   DEST=$2
306   fi   fi
307    
308     echo -e "${COLBLUE}>>>${COLGREEN} Unpacking ${SOURCEDIR}/${PNAME}/${SRCFILE}${COLDEFAULT}"
309    
310   [[ ! -d ${DEST} ]] && install -d ${DEST}   [[ ! -d ${DEST} ]] && install -d ${DEST}
311    
312   case "${SRCFILE##*.}" in   case "${SRCFILE##*.}" in
# Line 357  munpack() Line 356  munpack()
356   tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."   tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
357   ;;   ;;
358   rar)   rar)
359   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST} || die ".rar unpack failed."
360   ;;   ;;
361   zip|xpi|jar)   zip|xpi|jar)
362   unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."   unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
# Line 529  sminclude() Line 528  sminclude()
528   then   then
529   for i in $@   for i in $@
530   do   do
531   echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"   [[ ${SILENT} = 1 ]] || echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"
532   source ${SMAGESCRIPTSDIR}/include/${i}.sminc   source ${SMAGESCRIPTSDIR}/include/${i}.sminc
533   done   done
534   echo   [[ ${SILENT} = 1 ]] || echo
535     fi
536    }
537    
538    march()
539    {
540     local retval
541    
542     if [[ ! -z ${ARCH} ]]
543     then
544     echo "${ARCH}"
545     retval=0
546     else
547     retval=1
548     fi
549    
550     return "${retval}"
551    }
552    
553    marchvariable()
554    {
555     local retval
556     local var="$1"
557    
558     [[ -n ${var} ]] || die "marchvariable(): missing variable"
559    
560     if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
561     then
562     eval echo \$${var}_${ARCH/i*86/x86} | tr ';' '\n'
563     retval=0
564     else
565     retval=1
566     fi
567    
568     return "${retval}"
569    }
570    
571    marchsrcfile()
572    {
573     local retval
574     local var="$1"
575    
576     [[ -z ${var} ]] && var="SRCFILE"
577    
578     marchvariable "${var}" || die
579    }
580    
581    marchsrcdir()
582    {
583     local retval
584     local var="$1"
585    
586     [[ -z ${var} ]] && var="SRCDIR"
587    
588     marchvariable "${var}" || die
589    }
590    
591    marchdepend()
592    {
593     local retval
594     local var="$1"
595    
596     [[ -z ${var} ]] && var="DEPEND"
597    
598     if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
599     then
600     # evaluate with escape strings for the magefile if called by smage
601     # but do not escape if the smagefile was called by depwalker directly
602     if [[ ${SMAGE_DEPEND} = 1 ]]
603     then
604     eval echo \$${var}_${ARCH/i*86/x86} | tr ';' '\n'
605     else
606     echo "\$(eval echo \\\$${var}_\${ARCH/i*86/x86} | tr ';' '\n')"
607     fi
608     retval=0
609     else
610     retval=1
611   fi   fi
612    
613     return "${retval}"
614    }
615    
616    marchsdepend()
617    {
618     local retval
619     local var="$1"
620    
621     [[ -z ${var} ]] && var="SDEPEND"
622    
623     if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
624     then
625     # evaluate with escape strings for the magefile if called by smage
626     # but do not escape if the smagefile was called by depwalker directly
627     if [[ ${SMAGE_DEPEND} = 1 ]]
628     then
629     eval echo \$${var}_${ARCH/i*86/x86} | tr ';' '\n'
630     else
631     echo "\$(eval echo \\\$${var}_\${ARCH/i*86/x86} | tr ';' '\n')"
632     fi
633     retval=0
634     else
635     retval=1
636     fi
637    
638     return "${retval}"
639  }  }
640    
641  setup_distcc_environment()  setup_distcc_environment()
# Line 551  setup_distcc_environment() Line 653  setup_distcc_environment()
653   fi   fi
654  }  }
655    
656  setup_ccache_environment()  setup_icecc_environment()
657  {  {
658   if [ -x /usr/bin/ccache ]   if [ -x /usr/bin/icecc ]
659   then   then
660   echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"   echo -e "${COLBLUE}---${COLGREEN} Using IceCC for compilation ...${COLDEFAULT}"
661   export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   export PATH=/usr/$(mlibdir)/icecc/bin:${PATH} || die "icecc: could not export new $PATH"
662   fi   fi
663  }  }
664    
665  # fixes given dependencies to match a MAGE_TARGET  setup_ccache_environment()
666  # fix_mage_deps -target s/depend # <-- note -target !  {
667  fix_mage_deps()   if [ -x /usr/bin/ccache ]
 {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
668   then   then
669   # fix DEPEND   mqueryfeature "icecc" && export CCACHE_PREFIX=icecc
  while read sym dep  
  do  
  # ignore empty lines  
  [[ -z ${dep} ]] && continue  
   
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
670    
671   # doing it backwards !   echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"
672   pver="${dep##*-}"   export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
673   fi   fi
   
  echo "${depend}"  
674  }  }
675    
676  # build_mage_script(): helper functions for regen_mage_tree()  # build_mage_script(): helper functions for regen_mage_tree()
# Line 649  build_mage_script() Line 706  build_mage_script()
706  {  {
707   local magefile   local magefile
708   local dest   local dest
  local target  
709   local split_pkg_base   local split_pkg_base
710   local sym   local sym
711   local depname   local depname
# Line 657  build_mage_script() Line 713  build_mage_script()
713   # if MAGE_TREE_DEST not set use BUILDDIR   # if MAGE_TREE_DEST not set use BUILDDIR
714   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
715    
  # determinate which suffix this mage file should get, if any  
  [[ $1 = --target ]] && shift && target="-$1"  
   
716   # mark package as splitpackage   # mark package as splitpackage
717   [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"   [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
718    
719   # name of magefile   # name of magefile
720   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"   magefile="${PNAME}-${PVER}-${PBUILD}.mage"
721    
722   # destination to magefile   # destination to magefile
723   dest="${MAGE_TREE_DEST}/${PCAT}/${PNAME}${target}/${magefile}"   dest="${MAGE_TREE_DEST}/${PCAT}/${PNAME}/${magefile}"
724    
725   # show what we are doing   # show what we are doing
726   echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"
# Line 678  build_mage_script() Line 731  build_mage_script()
731   > ${dest}   > ${dest}
732    
733   # pgkname and state   # pgkname and state
734   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}   echo "PKGNAME=\"${PNAME}-${PVER}-\${ARCH}$(print_distrotag)-${PBUILD}\"" >> ${dest}
735   echo "STATE=\"${STATE}\"" >> ${dest}   echo "STATE=\"${STATE}\"" >> ${dest}
736    
737   # description and homepage   # description and homepage
# Line 691  build_mage_script() Line 744  build_mage_script()
744   # special tags and vars   # special tags and vars
745   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}
746    
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${target}\"" >> ${dest}  
   
747   # split package base   # split package base
748   echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}   echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
749    
# Line 722  build_mage_script() Line 772  build_mage_script()
772   fi   fi
773    
774   # deps and provides   # deps and provides
775   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}   echo "DEPEND=\"${DEPEND}\"" >> ${dest}
776   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}   echo "SDEPEND=\"${SDEPEND}\"" >> ${dest}
777   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
778    
779   # add special functions   # add special functions
# Line 734  build_mage_script() Line 784  build_mage_script()
784   do   do
785   # add to mage (quotes needed !)   # add to mage (quotes needed !)
786   typeset -f "${i}" >> ${dest}   typeset -f "${i}" >> ${dest}
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
787   done   done
788   fi   fi
789    
# Line 753  regen_mage_tree() Line 801  regen_mage_tree()
801   # build them only if requested   # build them only if requested
802   if mqueryfeature regentree   if mqueryfeature regentree
803   then   then
  # run it without targets  
  if [[ -n ${MAGE_TARGETS} ]]  
  then  
  # build for each target a mage file  
  # run it with several targets  
  echo  
  for subpackage in ${MAGE_TARGETS}  
  do  
  build_mage_script --target "${subpackage}"  
  done  
  echo  
   
804   # run it for splitpackages   # run it for splitpackages
805   elif [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
806   then   then
807   local split_pkg_base="${PNAME}"   local split_pkg_base="${PNAME}"
808   # save smage environment   # save smage environment
# Line 779  regen_mage_tree() Line 815  regen_mage_tree()
815   # get the right variables for the split   # get the right variables for the split
816   export PNAME="${subpackage}"   export PNAME="${subpackage}"
817   split_info_${subpackage}   split_info_${subpackage}
818     # fix PCATEGORIE -> PCAT
819     if [[ ! -z ${PCATEGORIE} ]]
820     then
821     PCAT="${PCATEGORIE}"
822     unset PCATEGORIE
823     fi
824   # get the preinstall etc   # get the preinstall etc
825   split_export_inherits ${subpackage}   split_export_inherits ${subpackage}
826   build_mage_script --split-pkg-base "${split_pkg_base}"   build_mage_script --split-pkg-base "${split_pkg_base}"
# Line 800  regen_mage_tree() Line 842  regen_mage_tree()
842    
843   # now unset all uneeded vars to be safe   # now unset all uneeded vars to be safe
844   # unset PKGNAME <-- don't do that; smage needs this var   # unset PKGNAME <-- don't do that; smage needs this var
  # unset to be safe (quotes needed !)  
 # for i in ${SPECIAL_FUNCTIONS}  
 # do  
 # unset "${i}"  
 # done  
845   unset SPECIAL_FUNCTIONS   unset SPECIAL_FUNCTIONS
 # for i in ${SPECIAL_VARS}  
 # do  
 # unset "${i}"  
 # done  
846   unset SPECIAL_VARS   unset SPECIAL_VARS
847   unset STATE   unset STATE
848   unset DESCRIPTION   unset DESCRIPTION
# Line 834  split_save_variables() Line 867  split_save_variables()
867   export SAVED_DESCRIPTION="${DESCRIPTION}"   export SAVED_DESCRIPTION="${DESCRIPTION}"
868   export SAVED_HOMEPAGE="${HOMEPAGE}"   export SAVED_HOMEPAGE="${HOMEPAGE}"
869   export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"   export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
870     export SAVED_SPECIAL_FUNCTIONS="${SPECIAL_FUNCTIONS}"
871   export SAVED_STATE="${STATE}"   export SAVED_STATE="${STATE}"
  export SAVED_PKGTYPE="${PKGTYPE}"  
872   export SAVED_INHERITS="${INHERITS}"   export SAVED_INHERITS="${INHERITS}"
873   export SAVED_DEPEND="${DEPEND}"   export SAVED_DEPEND="${DEPEND}"
874   export SAVED_SDEPEND="${SDEPEND}"   export SAVED_SDEPEND="${SDEPEND}"
# Line 909  split_restore_variables() Line 942  split_restore_variables()
942   export DESCRIPTION="${SAVED_DESCRIPTION}"   export DESCRIPTION="${SAVED_DESCRIPTION}"
943   export HOMEPAGE="${SAVED_HOMEPAGE}"   export HOMEPAGE="${SAVED_HOMEPAGE}"
944   export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"   export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
945     export SPECIAL_FUNCTIONS="${SAVED_SPECIAL_FUNCTIONS}"
946   export STATE="${SAVED_STATE}"   export STATE="${SAVED_STATE}"
  export PKGTYPE="${SAVED_PKGTYPE}"  
947   export INHERITS="${SAVED_INHERITS}"   export INHERITS="${SAVED_INHERITS}"
948   export DEPEND="${SAVED_DEPEND}"   export DEPEND="${SAVED_DEPEND}"
949   export SDEPEND="${SAVED_SDEPEND}"   export SDEPEND="${SAVED_SDEPEND}"
# Line 978  split_unset_variables() Line 1011  split_unset_variables()
1011   unset SAVED_DESCRIPTION   unset SAVED_DESCRIPTION
1012   unset SAVED_HOMEPAGE   unset SAVED_HOMEPAGE
1013   unset SAVED_SPECIAL_VARS   unset SAVED_SPECIAL_VARS
1014     unset SAVED_SPECIAL_FUNCTIONS
1015   unset SAVED_STATE   unset SAVED_STATE
1016   unset SAVED_PKGTYPE   unset SAVED_PKGTYPE
1017   unset SAVED_INHERITS   unset SAVED_INHERITS
# Line 1058  generate_package_md5sum() Line 1092  generate_package_md5sum()
1092   local pver   local pver
1093   local pbuild   local pbuild
1094   local parch   local parch
  local target  
1095   local pkgname   local pkgname
1096    
1097   # very basic getops   # very basic getops
# Line 1070  generate_package_md5sum() Line 1103  generate_package_md5sum()
1103   --pver|-v) shift; pver="$1" ;;   --pver|-v) shift; pver="$1" ;;
1104   --pbuild|-b) shift; pbuild="$1" ;;   --pbuild|-b) shift; pbuild="$1" ;;
1105   --parch|a) shift; parch="$1" ;;   --parch|a) shift; parch="$1" ;;
  --target|t) shift; target="$1" ;;  
1106   esac   esac
1107   shift   shift
1108   done   done
# Line 1086  generate_package_md5sum() Line 1118  generate_package_md5sum()
1118   [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."   [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."
1119   [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."   [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."
1120    
  # fix target as it may be empty !  
  [ -n "${target}" ] && target="-${target}"  
   
1121   # build pkgname   # build pkgname
1122   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"   pkgname="${pname}-${pver}-${parch}$(print_distrotag)-${pbuild}"
1123    
1124   # build pkg-md5-sum only if requested   # build pkg-md5-sum only if requested
1125   if mqueryfeature regentree   if mqueryfeature regentree
# Line 1108  generate_package_md5sum() Line 1137  generate_package_md5sum()
1137   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
1138    
1139   # setup md5 dir   # setup md5 dir
1140   dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"   dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"
1141   install -d ${dest}   install -d ${dest}
1142    
1143   # gen md5sum   # gen md5sum
# Line 1120  generate_package_md5sum() Line 1149  generate_package_md5sum()
1149    
1150  source_pkg_build()  source_pkg_build()
1151  {  {
  if [[ ${PKGTYPE} = virtual ]]  
  then  
  echo "Virtual package detected; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
1152   if [[ ! -d ${SOURCEDIR}/${PNAME} ]]   if [[ ! -d ${SOURCEDIR}/${PNAME} ]]
1153   then   then
1154   echo "No SRC_URI defined; src-pkg-tarball not necessary ..."   install -d ${SOURCEDIR}/${PNAME}
  return 0  
1155   fi   fi
1156    
1157   [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."   [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."
# Line 1143  source_pkg_build() Line 1165  source_pkg_build()
1165   [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}   [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}
1166   mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}   mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}
1167    
1168   echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"   echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}\n"
1169  }  }
1170    
1171  step_by_step()  step_by_step()
# Line 1175  run_resume() Line 1197  run_resume()
1197   return 1   return 1
1198   fi   fi
1199  }  }
1200    
1201    mqalint()
1202    {
1203     return 0
1204    }

Legend:
Removed from v.1648  
changed lines
  Added in v.3038